#!/bin/bash

# The purpose of this script is:
#   Create a script which sets up
#     (1) owner:group
#     (2) file mode(ie. rwx)
#     (3) selinux context(ie. u:object_r:xxx:s0)
#   of the each file on the target device.
#
# The Created script must be executed on the target device.
#
# Usage:
#   (step1) simg2img  SYSTEM_IMAGE  SYSTEM_IMAGE_RAW"
#   (step2) mount  SYSTEM_IMAGE_RAW  MOUNT_POINT"
#   (step3) ls -alnZR  MOUNT_POINT > INTPU_FILE"
#   (step4) This_script  INTPU_FILE > OUTPUT_SCRIPT"
#
#   OUTPUT_SCRIPT == The Created script


#---------------------------------------
# define patterns

#...directory name
PAT_DNAME="\/[^ ]*"
PAT_DNAME_EXE="(bin|xbin)"
PAT_DNAME_OTH="(app|etc|fonts|framework|lib|media|priv-app|usr)"

#...command
PAT_CMD_CHCON="chcon -h"
PAT_CMD_CHMOD="chmod"
PAT_CMD_CHOWN="chown"



#...file permission mode
PAT_MODE_TAIL="[wrxstSX-]{9}[^ ]*"
PAT_MODE=".[wrxstSX-]{9}[^ ]*"
PAT_MODE_DIR="d$PAT_MODE_TAIL"
PAT_MODE_FILE_OR_SLINK="[-l]$PAT_MODE_TAIL"
#...hard link count
PAT_LINK_COUNT="[0-9]+"
#...user group id
PAT_USER="[0-9]+"
PAT_GROUP="[0-9]+"
PAT_USER_GROUP="[0-9]+ +[0-9]+"
PAT_USER_GROUP_ROOT="0 +0"
PAT_USER_GROUP_SYSTEM="0 +2000"
#...context
PAT_CNTX="[^: ]+:[^: ]+:[^: ]+:[^: ]+"
PAT_CNTX_DEFAULT="u:object_r:system_file:s0"
#...time
PAT_TIME="[0-9]{1,2}:[0-9]{1,2}"
#...file name( without dir name )
PAT_FNAME="[^ /]+"
PAT_FNAME_DOT="\.{1,2}"

#---------------------------------------
# usage
usage()
{
    echo "Usage:"
    echo "  (step1) simg2img  SYSTEM_IMAGE  SYSTEM_IMAGE_RAW"
    echo "  (step2) mount  SYSTEM_IMAGE_RAW  MOUNT_POINT"
    echo "  (step3) ls -alnZR  MOUNT_POINT > INTPU_FILE"
    echo "  (step4) $0 INTPU_FILE > OUTPUT_SCRIPT"

    exit -1
};

#---------------------------------------
# INPUT_FILE <-- save args
if [ -z $1 ]
then
    usage
    exit -1
fi
INPUT_FILE=$1

# check INPUT_FILE
#...check if directory name exist
if ! grep -q "^/.*:$" $INPUT_FILE ; then
    echo "error: $INPUT_FILE has no directory.( ls without -R option )"
    usage
fi
#...check if context exist
if ! grep -q "$PAT_CNTX_DEFAULT" $INPUT_FILE ; then
    echo "error: $INPUT_FILE has no context.( ls without -Z option )"
    usage ;
fi
#...check if -n option is used
if grep -q "root root" $INPUT_FILE ; then
    echo "error: $INPUT_FILE has owner group by name.( ls without -n option )"
    usage
fi


# MNT_POINT <-- extract the mount point where 'ls -alnZR' command was executed for.
MNT_POINT=`grep '^/[^ ]*:$' $INPUT_FILE | sort | tail -n 1`
# ...remove ':' and escape /
MNT_POINT=${MNT_POINT%:}
MNT_POINT=${MNT_POINT//\//\\/}



#---------------------------------------
# output header
cat <<EOF
#!/system/bin/sh

# This scripts is generated by executing 'extract.sh' .
# This scripts must be run on the target device.


# Set MNT_POINT where the system partition is mounted.
MNT_POINT=/mnt/system

# check MNT_POINT
if [ ! -f \$MNT_POINT/build.prop ] ; then
    echo "error: \$MNT_POINT/build.prop does not exist. Please check MNT_POINT"
    exit -1
fi

# check some commands are available
for c in chcon chmod chown
do
    if ! command -v \$c > /dev/null ; then
        echo ERROR: \$c does not exist.
        exit 1
    fi
done
EOF

#---------------------------------------
# extract chcon command
# (1) IF the line is directory name
#     THEN
#       hold <-- extract <dir name> from the line(pat)
#       and skip the line
# (2) skip the line IF mode == dir
# (3) skip the line IF context == u:object_r:system_file:s0
# (4) generate_chcon_command IF mode == file or slink

# generate_chcon_command :
#  entry
#    hold space == <dir name>
#    pattern space == <mode> .* <context> .* <time> <file name>[ -> link_target]
#
#  pat <--append-- <new line> hold
#    ( pat == <mode> .* <context> .* <time> <filename>[ -> link_target]<new_line><dir name> )
#  chcon -h <context> <dir name>/<file name> <--replace-- pat
#  print

echo
echo
echo "#----chcon----"
cat <<EOF
echo "INFO: chcon"
#...default context
${PAT_CMD_CHCON}R  $PAT_CNTX_DEFAULT  \$MNT_POINT
#...other context
EOF

sed -E -n \
    -e "/^$PAT_DNAME:$/{ s/^$MNT_POINT(.*):/\$MNT_POINT\1/ ; h }" \
    -e "/^$PAT_MODE_DIR/d" \
    -e "/^.*$PAT_CNTX_DEFAULT/d" \
    -e "/^$PAT_MODE_FILE_OR_SLINK/{ G ; s/.* ($PAT_CNTX) .* $PAT_TIME ($PAT_FNAME).*\n(.*)/$PAT_CMD_CHCON \1 \3\/\2/M ; p }" \
    $INPUT_FILE | column -t


#---------------------------------------
# extract chmod command

# (1) IF the line is directory name
#     THEN
#       hold <-- extract <dir name> from the line(pat)
#       and skip the line
# (2) skip  IF mode != PAT_MODE_FILE_OR_DIR
# (3) skip  IF mode == PAT_MODE_DEFAULT_DIR
# (4) skip  IF <file name> == "." or ".."
# (5) pat <--append-- <new line> hold
#     ( pat == <mode> ... <file name> <new line> <dir name> )
# (6) skip  IF mode == rwxr-xr-x  AND <dir name> == [bin|xbin]
# (7) skip  IF mode == rw-r--r--  AND <dir name> == [app|etc|fonts|framework|lib|media|priv-app|usr]
# (8) generate chmod command
#     hold <-- pat
#     ( hold == <mode> .* <file name><new line><dir name> )
#     pat <-- convert <mode> from "rwx" format to "u=,g=,o=" format
#     pat <--append-- <new line> hold
#     ( pat == <mode(ugo)><new line><mode> .* <file name><new line><dir name> )
#     print "chmod <mode(ugo)> <dir name>/<file name>"
# (9) restore hold space to be <dir name>
#     pat <-- hold
#     ( pat == <mode> .* <file name><new line><dir name> )
#     pat <-- <dir name>
#     hold <-- pat


PAT_MODE_DEFAULT_DIR="drwxr-xr-x[^ ]*"
PAT_MODE_DEFAULT_EXE="-rwxr-xr-x[^ ]*"
PAT_MODE_DEFAULT_OTH="-rw-r--r--[^ ]*"
PAT_MODE_FILE_OR_DIR="[d-]$PAT_MODE_TAIL"


echo
echo
echo "#----chmod----"
cat <<EOF
echo "INFO: chmod"
# ...directory
echo "INFO: ... all directory"
find \$MNT_POINT -type d -not -name '.' -exec chmod 755 '{}' ';'
# ...bin,xbin
echo "INFO: ... bin xbin"
for dir in bin xbin ; do
    find \$MNT_POINT/\$dir -type f -not -name '.' -exec chmod 755 '{}' ';'
done
# ...app etc fonts framework lib media priv-app usr
echo "INFO: ... app etc fonts framework lib media priv-app usr"
for dir in app etc fonts framework lib priv-app usr ; do
    find \$MNT_POINT/\$dir -type f -not -name '.' -exec chmod 644 '{}' ';'
done
# ...other
echo "INFO: ... other"
EOF

sed -n -E \
    -e "/^$PAT_DNAME:$/{ s/^$MNT_POINT(.*):/\$MNT_POINT\1/ ; h }" \
    -e "/^$PAT_MODE_FILE_OR_DIR/! d" \
    -e "/^$PAT_MODE_DEFAULT_DIR/ d" \
    -e "/$PAT_FNAME_DOT$/ d" \
    -e "G" \
    -e "/^$PAT_MODE_DEFAULT_EXE .*\n.*\/$PAT_DNAME_EXE/M d" \
    -e "/^$PAT_MODE_DEFAULT_OTH .*\n.*\/$PAT_DNAME_OTH/M d" \
    -e "h" \
    -e "{ s/^.(...)(...)(...).*\n.*/o=\1,g=\2,o=\3/ ; s/-//g ; G }" \
    -e "s/^(.*)\n.* $PAT_TIME ($PAT_FNAME)\n(.*)/$PAT_CMD_CHMOD \1 \3\/\2/Mp" \
    -e "{ g ; s/^.*\n(.*)/\1/M ; h }" \
    -e "{ d }" \
    $INPUT_FILE | column -t



#---------------------------------------
# extract chown command


# (1) IF the line is directory name
#     THEN
#       hold <-- extract <dir name> from the line(pat)
#       and skip the line
# (2) skip  IF IF <file name> == "." or ".."
# (3) skip  IF ower_group == root root
# (3) skip  IF ower_group does not exist
# (5) pat <--append-- <new line> hold
#     ( pat == <mode> ... <file name> <new line> <dir name> )
# (6) skip  IF user_group == 0:2000  AND <dir name> == [bin|xbin]
# (7) generate_chown_command
#
# generate_chmod_command :
#   on entry
#     assume( pat == "<mode> <link count> <owner group> .* <date> <file name><new line><directory name>"
#   chown <owner group>  <directory name>/<file name> <-- genarate

echo
echo
echo "#----chown----"
cat <<EOF
echo "INFO: chown"
# ...bin,xbin
echo "INFO: ... bin,xbin"
for dir in bin xbin ; do
    find \$MNT_POINT/\$dir -type f -not -name '.' -exec chown 0:2000 '{}' ';'
done
#...other
echo "INFO: ... other"
EOF

sed -n -E \
    -e "/^$PAT_DNAME:$/{ s/^$MNT_POINT(.*):/\$MNT_POINT\1/ ; h }" \
    -e "/$PAT_FNAME_DOT$/ d" \
    -e "/^$PAT_MODE +$PAT_LINK_COUNT +$PAT_USER_GROUP_ROOT/ d" \
    -e "/^$PAT_MODE +$PAT_LINK_COUNT +$PAT_USER_GROUP/! d" \
    -e "G" \
    -e "/^$PAT_MODE +$PAT_LINK_COUNT +$PAT_USER_GROUP_SYSTEM.*\n.*\/$PAT_DNAME_EXE/M d" \
    -e "s/^$PAT_MODE +$PAT_LINK_COUNT +($PAT_USER) +($PAT_GROUP) .* $PAT_TIME ($PAT_FNAME)\n(.*)/$PAT_CMD_CHOWN \1:\2 \4\/\3/Mp" \
    $INPUT_FILE | column -t
